# TODO: Check if --with-kernel-dir=/usr/src/linux/include/  fix is OK
# ( https://dev.openwrt.org/ticket/12875 )
Summary:	HA monitor built upon LVS, VRRP and services poller
Summary(pl.UTF-8):	Monitor HA zbudowany w oparciu o LVS, VRRP i narzędzie do sprawdzania usług
Name:		keepalived
Version:	1.2.15
Release:	3
License:	GPL v2
Group:		Applications/System
Source0:	http://www.keepalived.org/software/%{name}-%{version}.tar.gz
# Source0-md5:	d85fcb8e564ea03b0ca7b2357bf30c51
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Patch0:		%{name}-config.patch
URL:		http://www.keepalived.org/
BuildRequires:	autoconf
BuildRequires:	automake
#BuildRequires:	kernel-source >= 2.6.0
BuildRequires:	openssl-devel >= 0.9.7d
BuildRequires:	popt-devel
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
Suggests:	genhash
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The main goal of the keepalived project is to add a strong & robust
keepalive facility to the Linux Virtual Server project. This project
is written in C with multilayer TCP/IP stack checks. Keepalived
implements a framework based on three family checks: Layer3, Layer4 &
Layer5. This framework gives the daemon the ability of checking a LVS
server pool states. When one of the server of the LVS server pool is
down, keepalived informs the Linux kernel via a setsockopt call to
remove this server entry from the LVS topology. In addition keepalived
implements a VRRPv2 stack to handle director failover. So in short
keepalived is a userspace daemon for LVS cluster nodes healthchecks
and LVS directors failover.

%description -l pl.UTF-8
Głównym celem projektu keepalived jest dodanie potężnego udogodnienia
keepalive do projektu Linux Virtual Server. Ten projekt jest napisany
w C z wielowarstwowym sprawdzaniem stosu TCP/IP. keepalived
implementuje szkielet oparty na sprawdzaniu trzech rodzin: warstwy 3,
warstwy 4 i warstwy 5. Ten szkielet daje demonowi możliwość
sprawdzania stanów puli serwerów LVS. Kiedy jeden serwer z puli
serwerów LVS przestaje działać, keepalived informuje o tym jądro
Linuksa poprzez wywołanie setsockopt w celu usunięcia wpisu o serwerze
z topologii LVS. Poza tym keepalived implementuje stos VRRPv2 do
obsługi przejmowania zadań (failover) samego urządzenia zarządzającego
(director). Czyli w skrócie keepalived to działający w przestrzeni
użytkownika demon do sprawdzania stanu węzłów klastra LVS oraz
przejmowania zadań urządzenia zarządzającego.

%package genhash
Summary:	genhash - md5 hash generation tool for remote web pages
Group:		Applications/System
Provides:	genhash

%description genhash
genhash is a tool used for generating md5sum hashes of remote web
pages. genhash can use HTTP or HTTPS to connect to the web page. The
output by this utility includes the HTTP header, page data, and the
md5sum of the data. This md5sum can then be used within the keepalived
program, for monitoring HTTP and HTTPS services.

%prep
%setup -q
%patch0 -p1

%build
%{__aclocal}
%{__autoconf}
%configure \
	STRIP=/bin/true \
	CFLAGS="%{rpmcflags}  -D_WITH_LINKWATCH_" \
	--with-kernel-dir=/usr/src/linux/include
#	CFLAGS="%{rpmcflags} -include %{_includedir}/linux/errno.h -D_WITH_LINKWATCH_"
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig}

%{__make} install \
	STRIP=/bin/true \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

# Cleanups:
rm -rf $RPM_BUILD_ROOT/etc/keepalived/samples
rm -f $RPM_BUILD_ROOT/etc/init.d/keepalived

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add keepalived
%service keepalived restart

%preun
if [ "$1" = "0" ]; then
	%service keepalived stop
	/sbin/chkconfig --del keepalived
fi

%files
%defattr(644,root,root,755)
%doc AUTHOR ChangeLog CONTRIBUTORS README TODO doc/samples doc/keepalived*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/keepalived/keepalived.conf
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%attr(755,root,root) %{_sbindir}/keepalived
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%dir %{_sysconfdir}/keepalived
%{_mandir}/man5/keepalived.conf.5*
%{_mandir}/man8/keepalived.8*

%files genhash
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/genhash
%{_mandir}/man1/genhash.1*
%changelog
* Wed Oct 06 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/keepalived.git;a=log;h=master

* Wed Oct 06 2021 Jan Rękorajski <baggins@pld-linux.org> 298e16d
- rel 3, fix debuginfo package

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 6be4ba7
- release 2 (by relup.sh)

* Fri Jan 23 2015 Mateusz Korniak <matkor@pld-linux.org> d8c49f8
- Version 1.2.15

* Sat May 26 2012 blekot <blekot@pld-linux.org> 5559195
- up to 1.2.2
- removed empty TODO list (done successfully)

* Wed Jan 19 2011 areq <areq@pld-linux.org> 86e4c16
- 1.2.1

* Sun May 16 2010 sparky <sparky@pld-linux.org> fbf437c
- BR: autoconf, automake

* Mon Apr 12 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 8817dd3
- release 3

* Mon Oct 19 2009 mguevara <mguevara@pld-linux.org> fa66896
- 1.1.19-2 - use autoconf to generate configure, configure not patched
  directly anymore

* Mon Oct 19 2009 mguevara <mguevara@pld-linux.org> 963b7a2
- 1.1.19-1

* Mon Oct 19 2009 mguevara <mguevara@pld-linux.org> 9bff40d
- rel 0.4 - moved genhash to the separate package

* Sun Oct 18 2009 mguevara <mguevara@pld-linux.org> 112ebe2
- rel 0.3, added keepalived-use-linux-libc-headers.patch to use llh instead
  of kernel-headers

* Sun Oct 18 2009 mguevara <mguevara@pld-linux.org> f2b2d5e
- rel 0.2 - added keepalived-config.patch - comments out the default
  config file

* Sun Oct 18 2009 mguevara <mguevara@pld-linux.org> 09c1b29
- up to 1.1.19-0.1

* Sat Sep 26 2009 areq <areq@pld-linux.org> 79238dd
- 1.1.18

* Fri Mar 06 2009 areq <areq@pld-linux.org> df75160
- 1.1.17

* Mon Feb 16 2009 areq <areq@pld-linux.org> 6779285
- 1.1.16

* Fri Dec 28 2007 zbyniu <zbyniu@pld-linux.org> 52f2821
- obsoleted

* Fri Dec 28 2007 zbyniu <zbyniu@pld-linux.org> d5721ff
- up to 1.1.15, man.patch obsoleted; _WITH_LINKWATCH_ forced

* Tue Apr 17 2007 Paweł Gołaszewski <blues@pld-linux.org> caa662d
- started to make it for human; man.patch added

* Tue Apr 17 2007 Paweł Gołaszewski <blues@pld-linux.org> de7c0e1
- mandir should mean mandir

